"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

TObjectWithProperties subclass:#TType
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-Types'
!

!TType class methodsFor:'documentation'!

copyright
"
    Copyright (C) 2015-now Jan Vrany

    This code is not an open-source (yet). You may use this code
    for your own experiments and projects, given that:

    * all modification to the code will be sent to the
      original author for inclusion in future releases
    * this is not used in any commercial software

    This license is provisional and may (will) change in
    a future.
"
! !

!TType methodsFor:'comparing'!

= anotherType
    ^ self subclassResponsibility

    "Created: / 25-08-2015 / 23:34:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

hash
    ^ self subclassResponsibility

    "Created: / 25-08-2015 / 23:33:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TType methodsFor:'operations'!

union: aTType
    TUnionType with: self with: aTType

    "Created: / 21-08-2015 / 18:36:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TType methodsFor:'printing & storing'!

printOn:aStream
    aStream nextPut: $<; space.
    self printWithoutAnglesOn:aStream.
    aStream space; nextPut: $>.

    "Modified: / 23-09-2015 / 16:32:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

printWithoutAnglesOn:aStream
    self subclassResponsibility

    "Created: / 21-08-2015 / 13:46:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TType methodsFor:'testing'!

isAutomaticType
    ^ false

    "Created: / 23-09-2015 / 16:32:28 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

isBlockType
    ^ false

    "Created: / 02-09-2015 / 17:09:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

isSimpleType
    ^ false
!

isSubtypeOf: anotherType
    self subclassResponsibility

    "Created: / 02-09-2015 / 17:09:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TType class methodsFor:'documentation'!

version
    ^ 'Path: jv/tea/compiler/TType.st, Version: 1.0, User: jv, Time: 2015-08-26T07:46:38.380+01'
!

version_HG
    ^ '$Path: jv/tea/compiler/TType.st, Version: 1.0, User: jv, Time: 2015-08-26T07:46:38.380+01$'
! !

